---
title: XRSession.environmentBlendMode
slug: Web/API/XRSession/environmentBlendMode
tags:
  - API
  - AR
  - Property
  - Read-only
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR Augmented Reality
  - WebXR Augmented Reality API
  - XRSession
  - augmented
  - environmentBlendMode
---
<div>{{APIRef("WebXR Device API")}}</div>

<p><span class="seoSummary">The {{domxref("XRSession")}} interface's <em>read-only</em> <code><strong>environmentBlendMode</strong></code> property identifies if—and to  what degree—the computer-generated imagery is overlaid atop the real world.</span> This is used to differentiate between fully-immersive VR sessions and AR sessions which render over a pass-through image of the real world, possibly partially transparently.</p>

<p>The value is a {{domxref("DOMString")}} which contains one of the values defined by the {{domxref("XREnvironmentBlendMode")}} enumerated type.</p>

<div class="notecard warning">
<p><strong>Important:</strong> <code>environmentBlendMode</code> is part of the <a href="https://immersive-web.github.io/webxr-ar-module/">WebXR Augmented Reality Module</a>, which has not yet reached a stable state. You should use caution when using its features.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>blendMode</em> = <em>xrSession</em>.environmentBlendMode;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} whose value is one of the strings found in the enumerated type {{domxref("XREnvironmentBlendMode")}}, defining if—and if so, how—virtual, rendered content is overlaid atop the image of the real world.</p>

<p>Permitted values are:</p>

<p>{{page("/en-US/docs/Web/API/XREnvironmentBlendMode", "Values")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR AR Module","#xrenvironmentblendmode-enum","XRSession.environmentBlendMode")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSession.environmentBlendMode")}}</div>
